#if !defined(AFX_DATAOBJECT_H__20000910_3325_A4FC_7711_0080AD509054__INCLUDED_)
#define AFX_DATAOBJECT_H__20000910_3325_A4FC_7711_0080AD509054__INCLUDED_

#pragma once


class CDataObject : 
   public CComObjectRootEx<CComMultiThreadModelNoCS>, 
   public IDataObjectImpl<CDataObject>
{
public:
   BEGIN_COM_MAP(CDataObject)
      COM_INTERFACE_ENTRY(IDataObject)
   END_COM_MAP()

   CComPtr<IDataAdviseHolder> m_spDataAdviseHolder;
   UINT m_cfHTML;
   CString m_sText;

   CDataObject()
   {
      m_cfHTML = ::RegisterClipboardFormat(_T("HTML Format"));
   }

   HRESULT IDataObject_GetData(FORMATETC *pFormatetc, STGMEDIUM *pMedium)
   {
      ATLTRACE(_T("DataObject::GetData\n"));
      ATLASSERT(pMedium);
      if( pMedium==NULL ) return E_POINTER;
      ZeroMemory(pMedium, sizeof(STGMEDIUM));
      ATLTRACE2(atlTraceControls,2,_T("Format = %x\n"), pFormatetc->cfFormat);
      ATLTRACE2(atlTraceControls,2,_T("TYMED = %x\n"), pFormatetc->tymed);

      if( pFormatetc->cfFormat!=m_cfHTML ) return ResultFromScode(DATA_E_FORMATETC);
      if( (pFormatetc->tymed & TYMED_HGLOBAL)==0 ) return ResultFromScode(DATA_E_FORMATETC);
     
      USES_CONVERSION;
      LPSTR pstr = const_cast<LPSTR>(T2CA((LPCTSTR)m_sText));
      int len = ::lstrlenA(pstr)+1;
      HGLOBAL hMem = ::GlobalAlloc(GMEM_SHARE|GMEM_MOVEABLE, len);
      if( hMem==NULL ) return E_OUTOFMEMORY;
      LPSTR p = (LPSTR)::GlobalLock(hMem);
      CopyMemory(p, pstr, len);
      ::GlobalUnlock(hMem);

      pMedium->tymed = TYMED_HGLOBAL;
      pMedium->hGlobal = hMem;
      pMedium->pUnkForRelease = NULL;

      return S_OK;
   }

   STDMETHOD(GetDataHere)(FORMATETC* /*pFormatetc*/, STGMEDIUM* /*pMedium*/)
   {
      ATLTRACE(_T("DataObject::GetDataHere\n"));
      return ResultFromScode(DATA_E_FORMATETC);
   }

   STDMETHOD(QueryGetData)(FORMATETC* pFormatetc)
   {
      if( pFormatetc->cfFormat!=m_cfHTML ) return E_FAIL;
      if( (pFormatetc->tymed & TYMED_HGLOBAL)==0 ) return E_FAIL;
      return S_OK;
   }
};

#endif // !defined(AFX_DATAOBJECT_H__20000910_3325_A4FC_7711_0080AD509054__INCLUDED_)

