#if !defined(AFX_HTMLDIALOG_H__20010723_11A4_C57F_E187_0080AD509054__INCLUDED_)
#define AFX_HTMLDIALOG_H__20010723_11A4_C57F_E187_0080AD509054__INCLUDED_

#pragma once

/////////////////////////////////////////////////////////////////////////////
// HTML Dialog
//
// Written by Bjarke Viksoe (bjarke@viksoe.dk)
// Copyright (c) 2000 Bjarke Viksoe.
//
// This code may be used in compiled form in any way you desire. This
// source file may be redistributed by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. 
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability if it causes any damage to you or your
// computer whatsoever. It's free, so don't hassle me about it.
//
// Beware of bugs.
//

#ifndef __ATLWFILE_H__
   #error This file requires atlwfile.h to be included first
#endif

#include <mshtmhst.h>
#include <urlmon.h>
#pragma comment(lib, "urlmon.lib")


// Shows a dialog with HTML contents. 
// Uses the MSHTML component's "showHTMLDialog()" method.
class CHtmlDialog
{
public:
   BOOL DoModal(HWND hWnd, BSTR HTML, VARIANT *pvIn, BSTR bstrOptions, VARIANT *pvOut)
   {
      ATLASSERT(HTML);
      ATLASSERT(bstrOptions); // Should not be empty
      ATLASSERT(pvOut);       // Should not be empty

      HINSTANCE hinstMSHTML = ::LoadLibrary(_T("MSHTML.DLL"));
      if( hinstMSHTML==NULL ) return FALSE;

      // The SHOWHTMLDIALOGFN typedef probably comes from the Platform SDK
      SHOWHTMLDIALOGFN *pfnShowHTMLDialog =
         (SHOWHTMLDIALOGFN*)::GetProcAddress(hinstMSHTML, "ShowHTMLDialog");
      if( pfnShowHTMLDialog==NULL ) return FALSE;

      if( hWnd==NULL ) hWnd = ::GetForegroundWindow();
      ATLASSERT(::IsWindow(hWnd));

#ifdef HTMLDLG_USEABOUT
      CComBSTR bstrText(L"about:"); // use the *secret* "about:" protocol
      bstrText += HTML;
#else
      USES_CONVERSION;
      // TODO: Don't use inline (stack-based) conversion for a possible very large string.
      // BUG: Need to convert to UTF-8
      TCHAR szFilename[MAX_PATH];
      CTemporaryFile f;     
      f.Create(szFilename, MAX_PATH);
      f.Write(OLE2CA(HTML), wcslen(HTML));
      f.Close();
      CComBSTR bstrText(L"file:///");
      bstrText += szFilename;
#endif

      CComPtr<IMoniker> spMoniker;
      HRESULT hr;
      hr = ::CreateURLMoniker(NULL, bstrText, &spMoniker);
      if( SUCCEEDED(hr) ) {
         USES_CONVERSION;
         hr = (*pfnShowHTMLDialog)(hWnd, spMoniker.p, pvIn, OLE2W(bstrOptions), pvOut);
         spMoniker.Release();
      }
      ::FreeLibrary(hinstMSHTML);
      return hr==S_OK;
   }
};

#endif // !defined(AFX_HTMLDIALOG_H__20010723_11A4_C57F_E187_0080AD509054__INCLUDED_)

