#if !defined(AFX_PREVIEWVIEW_H__20000909_2E4A_878D_535E_0080AD509054__INCLUDED_)
#define AFX_PREVIEWVIEW_H__20000909_2E4A_878D_535E_0080AD509054__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CPreviewView : 
   public CWindowImpl<CPreviewView, CAxWindow>,
   public CTextPersist
{
public:
   DECLARE_WND_SUPERCLASS(NULL, CAxWindow::GetWndClassName())

   CComQIPtr<IDHTMLEdit> m_spDHTML;

   BEGIN_MSG_MAP(CPreviewView)
      MESSAGE_HANDLER(WM_CREATE, OnCreate)
      COMMAND_ID_HANDLER(ID_FILE_PRINT, OnPrint)
   END_MSG_MAP()

   // -----------------------------------

   HWND Create(HWND hWndParent, RECT& rcPos)
   {
      DWORD dwFlags = WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
      return CWindowImpl<CPreviewView, CAxWindow>::Create(hWndParent, rcPos, _T("DHTMLEdit.DHTMLEdit"), dwFlags);
   }
   
   // -----------------------------------

   LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
   {
      // Create the control for me
      DefWindowProc(uMsg, wParam, lParam);

      HRESULT hr;
      hr = QueryControl(IID_IDHTMLEdit, (LPVOID *)&m_spDHTML);
      if( FAILED(hr) ) return 1;
      m_spDHTML->put_BrowseMode(VARIANT_TRUE);

      bHandled = TRUE;
      return 0;
   }

   LRESULT OnPrint(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
   {
      CComVariant vIn;
      m_spDHTML->PrintDocument(&vIn);
      return 0;
   }

   // -----------------------------------

   BOOL PreTranslateMessage(MSG* pMsg)
   {
      if((pMsg->message < WM_KEYFIRST || pMsg->message > WM_KEYLAST) &&
         (pMsg->message < WM_MOUSEFIRST || pMsg->message > WM_MOUSELAST))
         return FALSE;

      // Give OCX a chance to translate this message
      return (BOOL)SendMessage(WM_FORWARDMSG, 0, (LPARAM)pMsg);
   }

   // -----------------------------------

   CComBSTR GetText()
   {
      ATLASSERT(m_spDHTML);
      WaitBusy();
      CComBSTR bstr;
      HRESULT hr = m_spDHTML->get_DocumentHTML(&bstr);
      if( FAILED(hr) ) return NULL;
      return bstr;
   }
   
   void SetText(CComBSTR &bstr)
   {
      ATLASSERT(m_spDHTML);
      HRESULT Hr;
      Hr = m_spDHTML->put_DocumentHTML(bstr);
      if( FAILED(Hr) ) return;
      WaitBusy();
   }

private:
   void WaitBusy() const
   {
      ATLASSERT(m_spDHTML);
      // Wait until document has been read.
      //VARIANT_BOOL vbBusy;
      //while( (m_spDHTML->get_Busy(&vbBusy)==S_OK) && vbBusy==VARIANT_TRUE ) ;
   }
};


#endif // !defined(AFX_PREVIEWVIEW_H__20000909_2E4A_878D_535E_0080AD509054__INCLUDED_)

